%define _use_internal_dependency_generator 0
%define __find_requires %{SOURCE99}

Summary: A secure replacement for inetd.
Name: xinetd
Version: 2.3.14
Release: 16%{?dist}
License: xinetd
Group: System Environment/Daemons
Epoch: 2
URL: http://www.xinetd.org
Source: http://www.xinetd.org/xinetd-%{version}.tar.gz
Source1: xinetd.init
Source2: xinetd-inetdconvert
Source3: xinetd.sysconf
Source99: filter-requires-xinetd.sh
Patch0: xinetd-2.3.11-pie.patch
Patch1: xinetd-2.3.12-tcp_rpc.patch
Patch2: xinetd-2.3.14-label.patch
Patch3: xinetd-2.3.14-contextconf.patch
Patch6: xinetd-2.3.14-man-section.patch
Patch11: xinetd-2.3.14-poll.patch
Patch12: xinetd-2.3.14-file-limit.patch
Patch14: xinetd-2.3.14-clean-pfd.patch
Patch15: xinetd-2.3.14-udp-reconfig.patch
Patch16: xinetd-2.3.13-log-crash.patch
Patch17: xinetd-2.3.14-rpc-specific-port.patch
Patch18: xinetd-2.3.14-signal-log-hang.patch
Patch19: xinetd-2.3.14-fix-type-punned-ptr.patch

BuildRequires: autoconf, automake
BuildRequires: libselinux-devel >= 1.30
Requires: /sbin/chkconfig /etc/init.d /sbin/service
%{!?tcp_wrappers:BuildRequires: tcp_wrappers}
Requires: filesystem >= 2.0.1, initscripts, setup, fileutils
Provides: inetd
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Obsoletes: inetd, netkit-base

%description
Xinetd is a secure replacement for inetd, the Internet services
daemon. Xinetd provides access control for all services based on the
address of the remote host and/or on time of access and can prevent
denial-of-access attacks. Xinetd provides extensive logging, has no
limit on the number of server arguments, and lets you bind specific
services to specific IP addresses on your host machine. Each service
has its own specific configuration file for Xinetd; the files are
located in the /etc/xinetd.d directory.

%prep
%setup -q  
%patch0 -p0 -b .pie
%patch1 -p1 -b .tcp_rpc
%patch2 -p1 -b .lspp
%patch3 -p1 -b .contextconfig
%patch6 -p1 -b .man-section
%patch11 -p1 -b .poll
%patch12 -p1 -b .file-limit
%patch14 -p1 -b .clean-pfd
%patch15 -p1 -b .udp-reconfig
%patch16 -p1 -b .log-crash
%patch17 -p1 -b .rpc-specific-port
%patch18 -p1 -b .signal-log-hang
%patch19 -p1 -b .fix-type-punned-ptr

aclocal
autoconf

%build
%configure --with-loadavg --with-inet6 %{!?tcp_wrappers:--with-libwrap} --with-labeled-networking
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d/
# Remove unneeded service
rm -f contrib/xinetd.d/ftp-sensor
%makeinstall DAEMONDIR=$RPM_BUILD_ROOT/usr/sbin MANDIR=$RPM_BUILD_ROOT/%{_mandir}
install -m 644 contrib/xinetd.conf $RPM_BUILD_ROOT/etc
install -m 644 contrib/xinetd.d/* $RPM_BUILD_ROOT/etc/xinetd.d
install -m 755 %SOURCE1 $RPM_BUILD_ROOT/etc/rc.d/init.d/xinetd
install -m 755 %SOURCE2 $RPM_BUILD_ROOT/usr/sbin/inetdconvert

rm -f $RPM_BUILD_ROOT/%{_mandir}/man8/itox*
rm -f $RPM_BUILD_ROOT/usr/sbin/itox
rm -f $RPM_BUILD_ROOT/%{_mandir}/man8/xconv.pl*
rm -f $RPM_BUILD_ROOT/usr/sbin/xconv.pl

mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
install -m 644 %SOURCE3 $RPM_BUILD_ROOT/etc/sysconfig/xinetd

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add xinetd 
fi

%preun
if [ $1 = 0 ]; then
    /sbin/service xinetd stop > /dev/null 2>&1
    /sbin/chkconfig --del xinetd 
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service xinetd condrestart >/dev/null 2>&1
fi


%files
%defattr(-,root,root)
%doc INSTALL CHANGELOG COPYRIGHT README xinetd/sample.conf contrib/empty.conf 

%config(noreplace) /etc/xinetd.conf
%config(noreplace) /etc/sysconfig/xinetd
/etc/rc.d/init.d/xinetd
%config(noreplace) /etc/xinetd.d/*
/usr/sbin/xinetd
/usr/sbin/inetdconvert
%{_mandir}/*/*

%changelog
* Fri Jan 06 2012 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 2:2.3.14-16
- Add additional missing patch to fix log message flooding (#754444)
- Add additional missing patch to fix no_files limit (#639447)

* Tue Dec 06 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 2:2.3.14-15
- Fix log message flooding when turning off UDP service during online
  reconfiguration (#754444)

* Mon Oct 17 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 2:2.3.14-14
- Add poll.patch - replace select() by poll() (#639447)
- Change License field to xinetd
- Change order of patches, rename contextmerge.patch to contextconf.patch
  (and adapt) for fedora/RHEL-6 patches compatibility

* Tue May 03 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 2:2.3.14-13
- Fix rpmlint errors: Prereq tag substituted with Requires tag,
  removed config mark from /etc/rc.d/init.d/xinetd executable

* Tue Apr 12 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 2:2.3.14-12
- Fix Rpmdiff build warning about "dereferencing type-punned pointer"
  Resolve: #695674

* Fri Apr 08 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 2:2.3.14-11
- Fix return values of xinetd.init script (LSBC Specification 3.2)
  Resolves: #498119
- Avoid possible hang while logging an unexpected signal
  Resolves: #501604
- Move documentation of xinetd.log to the right man section
  Resolves: #428811
- Fix crash when application's logfile hit size limit
  Resolves: #438986
- Let RPC services bind to a specific port
  Resolves: #624800

* Fri Dec 01 2006 James Antill <james.antill@redhat.com> - 2:2.3.14-10.el5
- Use SC_SERVER instead of SC_SERVER_ARGV
- Fix getpeercon() for LABELED networking MLS environments
- Resolves: rhbz#209379

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 2:2.3.14-8
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Wed Sep 20 2006 Steve Grubb <sgrubb@redhat.com> 2:2.3.14-7
- Revised labeled networking patch to not allow redirection

* Tue Aug 29 2006 Steve Grubb <sgrubb@redhat.com> 2:2.3.14-6
- Revised labeled networking patch again

* Thu Aug 24 2006 Steve Grubb <sgrubb@redhat.com> 2:2.3.14-5
- Revised labeled networking patch

* Wed Aug 23 2006 Steve Grubb <sgrubb@redhat.com> 2:2.3.14-4
- Added labeled networking patch

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2:2.3.14-3.1
- rebuild

* Fri Jun 16 2006 Steve Grubb <sgrubb@redhat.com> 2:2.3.14-3
- Rework spec file & use xinetd's sevice config files

* Fri Mar 24 2006 Jay Fenlason <fenlason@redhat.com> 2:2.3.14-2
- Upgrade to new upstream version.  This obsoletes the -libwrap,
  -rpc, -banner, -bug140084 and -gcc4 patches.

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 2:2.3.13-6.2.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 2:2.3.13-6.2
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Feb 17 2005 Jay Fenlason <fenlason@redhat.com> 2:2.3.13-6
- include new patch to allow gcc4 to compile xinetd.

* Sat Jan 8 2005 Jay Fenlason <fenlason@redhat.com> 2:2.3.13-4
- Added patch committed to upstream CVS to fix bz#140084
  (error logging accidentally using one of [012] as the syslog
  descriptor)

* Fri Jun 18 2004 Jay Fenlason <fenlason@redhat.com> 2:2.3.13-3
- Add patch to fix #126242: banner's don't work

* Thu Jun 17 2004 Jay Fenlason <fenlason@redhat.com>
- Remove the configuration for the no-longer-present "services" service.
  Closes #126169

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri May 14 2004 Jay Fenlason <fenlason@redhat.com>
- Add patch to allow multiple rpc services to cooexist as long as they're
  different program numbers or different versions.

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Jan 29 2004 Jay Fenlason <fenlason@redhat.com> 2.3.13-1
- Upgrade to new upstream version, which obsoletes most patches.
- Add new tcp_rpc patch, to turn on the nolibwrap flag on tcp rpc services,
  since libwrap cannot be used on them.

* Sun Dec 28 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- use new technology to filter python dep for inetdconvert instead
  of changing the -x bit on file permissions

